/*******************************************************************************
 * Institute for System Programming of the Russian Academy of Sciences
 * Copyright (c) 2009-2013
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 ******************************************************************************/
package com.unitesk.requality_subclipse;

import java.util.ArrayList;
import java.util.List;

import org.osgi.framework.BundleContext;
import org.tigris.subversion.subclipse.core.CancelableSVNStatusCallback;
import org.tigris.subversion.svnclientadapter.ISVNClientAdapter;

import com.unitesk.requality.eclipse.cvs.CVSSourcePlugin;
import com.unitesk.requality.eclipse.cvs.ICVSClient;

//import org.osgi.framework.Bundle;
//import org.tigris.subversion.svnclientadapter.SVNClientAdapterFactory;
//import org.tigris.subversion.svnclientadapter.javahl.JhlClientAdapterFactory;
//import org.tigris.subversion.svnclientadapter.commandline.CmdLineClientAdapterFactory;
//import org.tigris.subversion.svnclientadapter.svnkit.*;

public class CVCLOverSubclipsePlugin extends CVSSourcePlugin {
	public static String ID="org.tigris.subversion.subclipse.core.svnnature";
	private static ISVNClientAdapter svnCl = null;
	private org.tigris.subversion.subclipse.core.SVNClientManager svnClMng = null;

	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext)
	 */
	
	public CVCLOverSubclipsePlugin() {
		super();
		svnClMng = new org.tigris.subversion.subclipse.core.SVNClientManager();
		try {
			svnClMng.startup(null);
		}
		catch(Exception ex) {
			ex.printStackTrace();
		}
	}
	
	protected void actualStart(BundleContext bundleContext) throws Exception {
		
		//TODO различать исключения, когда класса нет, а когда повторная инициализауия
		// привязываем javahl
		//JhlClientAdapterFactory.setup();
		
		// привязываем SVNKit (почему-то не работает?!?!?!?)
		//SvnKitClientAdapterFactory.setup();

		// привязываем реадизацию через командную строку (не работает, нет плагина или пакета)
		//CmdLineClientAdapterFactory.setup();
			
		// выясняем, кто из возможных клиентов выбран пользователем по умолчанию и инициализируем его
		//svnCl = SVNClientAdapterFactory.createSVNClient(SVNClientAdapterFactory.getPreferredSVNClientType());
		
		/*Bundle[] bndls = bundleContext.getBundles();
		
		for(int i = 0; bndls != null && i < bndls.length; i++) {
			if(bndls[i].getSymbolicName().equals("org.tigris.subversion.clientadapter.svnkit")) {
				System.out.println("Here it is!");
				try {
					String activator = (String)bndls[i].getHeaders().get(org.eclipse.osgi.framework.internal.core.Constants.BUNDLE_ACTIVATOR);
					Class<?> activatorClass = bndls[i].loadClass(activator);
					Method method1 = activatorClass.getMethod("getDefault");
					Method method2 = activatorClass.getMethod("getAdapter");
					Object activatorInstance = method1.invoke(null);
					Object SvnKitClientAdapterInstance = method2.invoke(activatorInstance);
					System.out.println(SvnKitClientAdapterInstance.toString());
				}
				catch(Exception ex) {
					ex.printStackTrace();
				}
			}
		}*/

		if(svnCl != null) {
			svnClMng.returnSVNClient(svnCl);
			svnCl = null;
		}
		
		svnCl = svnClMng.getSVNClient();
		//aaa.addToIgnoredPatterns(arg0, arg1);
		
		//System.out.println(svnCl.toString());
		//System.out.println(aaa.toString());
	}
	
	public ISVNClientAdapter getSubclipseClientAdapter() {
		return svnCl;
	}

	public List<String> getSupportedTeamProvidersIDList() throws Exception {
		List<String> result = new ArrayList<String>();
		result.add(ID);
		result.add("org.eclipse.team.svn.core.svnnature");
		return result;
	}

	@Override
	public ICVSClient getInstanceOfSVCClient() throws Exception {
		if(
			((CVCLOverSubclipsePlugin) CVCLOverSubclipsePlugin.getDefault()).getSubclipseClientAdapter() != null
		) return new SVCSubclipseClient();
		throw new Exception("The CVCL over Subclipse plug-in has been badly started");
	}

	@Override
	protected void actualStop(BundleContext bundleContext) throws Exception {
		if(svnCl != null) svnClMng.returnSVNClient(svnCl);
		svnClMng.shutdown(null);
		svnClMng = null;
	}

}
